///////////////////////////////////////////////////////////////////////////////
// This file is part of "MMV - MegaloManic Venture", which is a demo which took
// part in Ohjelmointiputka's "Demokilpailu 2005" in January 2005.
//
// Copyleft Matti "Deewiant" Niemenmaa, 2004-2005.
//
// Filename: end.cc
//           All the code for the ending credits and stuff...
//
// File created: 2005-01-02
///////////////////////////////////////////////////////////////////////////////

#include "header.hh"
#include <string>

std::string endText = "\
That was/will be 2005, (very) summarized\n\
\n\
Hope you enjoyed it\n\
\n\
Only credits, thanks, and greetz left.\n\
\n\
The Guru Posse thanks you for your patience..."
,

creds = "\
MMV - MegaloManic Venture\n\
\n\
Copyleft 2004-2005 Guru Posse\n\
\n\
Matti \"Deewiant\" Niemenmaa: code, graphics, fx, design\n\
                  markdark: tracking, bugfixing, some design"
,

Deew = "\
Deewiant says:\n\
\n\
Phew, managed to finish it in time\n\
\n\
... well, I've got nothing special to say, so...\n\
\n\
Thanks to:\n\
 Jeff Molofee (NeonHelium / NeHe) for his excellent OpenGL tutorials\n\
 The OpenGL ARB for an excellent API\n\
 Sven Olsen for the Freetype library\n\
 Marcus Geelnard for GLFW\n\
 Firelight Multimedia for MiniFMOD\n\
 Google for a pretty damn handy search engine\n\
 and all the people whose code I ripped and whose names I forgot to take\n\
\n\
Greetz:\n\
 my classmates and teachers at Ressun Lukio\n\
 (yeah, and other schools but I have no time to mention them all)\n\
 Future Crew, farbrausch - these guys redefined the word \"guru\"\n\
 ElectroMotive Force (EMF)\n\
 The Space Pigs\n\
 Triton\n\
 Cascada - part of the inspiration for this probably came from \"Cronologia\"\n\
 Renaissance\n\
 Majic 12\n\
 ... and a bunch of people I forgot to mention\n\
\n\
Hmm... I'm probably a bit late with some of these, but oh well\n\
\n\
Get what others have got, while the getting is good."
,

mark = "\
markdark says:\n\
\n\
Y0 peeps, the music on this is by yours truly!\n\
Samples ripped from various and not cleared.\n\
Female vocals courtesy of AT&T.\n\
\n\
Finnish Tcl manual coming soon,\n\
exclusively at Ohjelmointiputka.net!\n\
\n\
http://darkmark.zapto.org forever baybe!!!!111oneonetwo\n\
\n\
PS. Hope you noticed the impeccable timing on the\n\
background music and the fx.\n\
\n\
Speed-composed in less than thirty minutes,\n\
including sfx and sample editing as well as finding a\n\
tracker.\n\
\n\
Greetz: All the posse at ModPlug.com, Ohjelmointiputka.net,\n\
finet.binaries.keskustelu.\n\
\n\
Always living, never dying. BitTorrent to the max.\n\
\n\
Fuck the police!"
,

finalEnd = "Be seeing ya...";

double aika;
unsigned char red, green, blue;

/******************************************************************************\
Function countLines()

Counts the number of lines in a string.

Inputs:
	text    The string whose lines to count.
\******************************************************************************/
int countLines(std::string text)
{
	int rowNum = 1;

	for (std::string::iterator i = text.begin(); i != text.end(); ++i)
		if (*i == '\n')
			++rowNum;

	return rowNum;
}

/******************************************************************************\
Function someText()
Function credits()
Function Deewiant()
Function markdark()
Function theRealEnd()

Form the texts at the end. There's no real reason for them to be in separate
functions, except logical grouping of which part.
\******************************************************************************/
void someText()
{
	double yPos = 0;
	double hetki = 5;
	int rowNum = countLines(endText);
	red = blue = green = 255;

	glfwSetTime(0);

	do {
		aika = glfwGetTime();
		glViewport(0, 0, 1024, 768);
		glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
		glLoadIdentity();

		blue = static_cast<unsigned char>(aika) * 255 / (static_cast<unsigned char>(hetki) / 2);
		glColor3ub(red, green, blue);

		// each row is around 28 pixels
		yPos = aika * (768 + rowNum * 28) / hetki;
		kirjoita(fonts[proFontSmall], 16, yPos, endText.c_str());

		glfwSwapBuffers();

	} while (aika <= hetki && glfwGetWindowParam(GLFW_OPENED));

	return;
}

void credits()
{
	double yPos = 0;
	double hetki = 5;
	int rowNum = countLines(creds);
	red = blue = green = 255;

	glfwSetTime(0);

	do {
		aika = glfwGetTime();
		glViewport(0, 0, 1024, 768);
		glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
		glLoadIdentity();

		red = static_cast<unsigned char>(aika) * 255 / (static_cast<unsigned char>(hetki) / 2);
		glColor3ub(red, green, blue);

		yPos = aika * (768 + rowNum * 28) / hetki;
		kirjoita(fonts[proFontSmall], 16, yPos, creds.c_str());

		glfwSwapBuffers();

	} while (aika <= hetki && glfwGetWindowParam(GLFW_OPENED));

	return;
}

void Deewiant()
{
	double yPos = 0;
	double hetki = 17;
	int rowNum = countLines(Deew);
	red = blue = green = 255;

	glfwSetTime(0);

	do {
		aika = glfwGetTime();
		glViewport(0, 0, 1024, 768);
		glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
		glLoadIdentity();

		blue  = 230 + static_cast<unsigned char>(aika) *  25 / (static_cast<unsigned char>(hetki)) / 2;
		red   = 100 + static_cast<unsigned char>(aika) * 155 / (static_cast<unsigned char>(hetki)) / 3;
		green =   5 + static_cast<unsigned char>(aika) * 250 / (static_cast<unsigned char>(hetki)) / 4;
		glColor3ub(red, green, blue);

		yPos = aika * (768 + rowNum * 28) / hetki;
		kirjoita(fonts[proFontSmall], 16, yPos++, Deew.c_str());

		glfwSwapBuffers();

	} while (aika <= hetki && glfwGetWindowParam(GLFW_OPENED));

	return;
}

void markdark()
{
	double yPos = 0;
	double hetki = 14;
	int rowNum = countLines(mark);
	red = blue = green = 255;

	glfwSetTime(0);

	do {
		aika = glfwGetTime();
		glViewport(0, 0, 1024, 768);
		glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
		glLoadIdentity();

		blue  = 180 + static_cast<unsigned char>(aika) * 75  / (static_cast<unsigned char>(hetki)) / 2;
		red   = 100 + static_cast<unsigned char>(aika) * 155 / (static_cast<unsigned char>(hetki)) / 4;
		green = 155 + static_cast<unsigned char>(aika) * 100 / (static_cast<unsigned char>(hetki)) / 3;
		glColor3ub(red, green, blue);

		yPos = aika * (768 + rowNum * 28) / hetki;
		kirjoita(fonts[proFontSmall], 16, yPos++, mark.c_str());

		glfwSwapBuffers();

	} while (aika <= hetki && glfwGetWindowParam(GLFW_OPENED));

	return;
}

void theRealEnd()
{
	double xPos = -384;
	red = blue = green = 255;

	glfwSetTime(-100);

	do {
		aika = glfwGetTime();
		glViewport(0, 0, 1024, 768);
		glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
		glLoadIdentity();

		glColor3ub(red, green, blue);

		kirjoita(fonts[proFont], xPos, 448, finalEnd.c_str());
		if (xPos == 32) {
			glfwSetTime(0);
			++xPos;
		} else xPos += 2;

		glfwSwapBuffers();

	} while (aika < 0.8 && glfwGetWindowParam(GLFW_OPENED));

	return;
}
